package de.letsbuildacompiler.compiler;

import de.letsbuildacompiler.parser.DemoLexer;
import de.letsbuildacompiler.parser.DemoParser;
import org.antlr.v4.runtime.CharStream;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CodePointCharStream;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.tree.ParseTree;

public class Main {
    public static void main(String[] args) {
        CodePointCharStream input = CharStreams.fromString("print(2 < 2);");
        System.out.println(compile(input));
    }

    public static String compile(CharStream input) {
        DemoLexer lexer = new DemoLexer(input);
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        DemoParser parser = new DemoParser(tokens);

        ParseTree tree = parser.program();
        FunctionList definedFunctions = FunctionDefinitionFinder.findFunctions(tree);
        return createJasminFile(new JasminVisitor(definedFunctions).visit(tree));
    }

    private static String createJasminFile(String instructions) {
        return ".class public HelloWorld\n" +
                ".super java/lang/Object\n" +
                "\n" +
                instructions;
    }
}
